<?php

include( "../lib/http.php");

session_start();

header("Content-type: text/css" );

// default values
$theme = 'blue';
$wallpaper = "";
$fontFamily = '"Ms Sans Serif","Helvetica"';
$fontFamily = "Arial,Helvetica";
$baseFontSize = "10px";
$prefs['PageTextColor'] = "gray";
$prefs['PageBgColor'] = "#40A0C0";
$prefs['LineColor'] = "gray";

if( isset($profile) )
{
        isset( $profile['theme_theme'] ) && $theme = $profile['theme_theme'];
        isset( $profile['theme_wallpaper'] ) && $wallpaper = $profile['theme_wallpaper'];
        isset( $profile['theme_paneltitlebg'] ) && $titlebgimage = $profile['theme_paneltitlebg'];
        $baseFontSize = $profile['theme_fontSize'];
        $fontFamily =  $profile['theme_fontFamily'];
}


// loads a theme informations into $prefs array
include_once( "../themes/" . $theme . ".php" );

?>

body {
        font-family: <?php echo $fontFamily ?>;
        font-size: <?php echo $baseFontSize ?>;
        color: <?php echo $prefs['PageTextColor'] ?>;
        background: <?php echo $prefs['PageBgColor'] ?>;
        <?php
        if( !empty($wallpaper) )
                echo "background-image: url(\"../themes/backgrounds/$wallpaper\"); ";
        ?>
}

/* module table */
.module
{
        font-family: inherit;
        background-color: <?php echo $prefs['PanelBgColor'] ?>;
        border-top:1px solid <?php echo $prefs['LineColor'] ?>;
        border-left:1px solid <?php echo $prefs['LineColor'] ?>;
        border-bottom:1px solid black;
        border-right:1px solid black;
}

/* module title table & elements */
.winTitle {
        font-size: <?php echo $baseFontSize ?>;
        color: <?php echo $prefs['TitleTextColor'] ?>;
        background: <?php echo $prefs['TitleBgColor'] ?>;
        <?php
        if( !empty($titlebgimage) )
                echo "background-image: url(\"../themes/backgrounds/$titlebgimage\"); ";
        ?>
}

/* content of a page module */
.panel {
        color: <?php echo $prefs['PanelTextColor'] ?>;
        background: <?php echo $prefs['PanelBgColor'] ?>;
        padding: 2px 6px 2px 10px;
}

.panel > input[type=text] {
        color: <?php echo $prefs['PanelTextColor'] ?>;
        background-color: <?php echo $prefs['PanelBgColor'] ?>;
        border: 1px solid gray;
}

/* table grid of data */
.grid {
        background: white;
        padding:2 2 2 2;
        border-width: 0 0;
}

/* grid title TD */
.listTitle {
        font-family: <?php echo $fontFamily ?>;
        font-size: <?php echo $baseFontSize ?>;
        font-weight: bold;
        color: <?php echo $prefs['TitleTextColor'] ?>;
        background-color: <?php echo $prefs['altBgColor'] ?>;
/*	background: <?php echo $prefs['GridBgColor'] ?>;*/
        border-width: 0px;
        border-bottom: 1px solid gray;
}

A {
        font-family: <?php echo $fontFamily ?>;
        text-decoration: none;
        color: <?php echo  $prefs['PanelTextColor'] ?>;
}

/* links in menu and navbar */
A.menu {
        font-family: <?php echo $fontFamily ?>;
         font-size: <?php echo $baseFontSize ?>;
         text-decoration: none;
        color: <?php echo $prefs['TitleTextColor'] ?>;
}

A.menu:hover {
        font-weight: bold;
        text-decoration: underline;
}

/* disabled link */
.disabled {
        font-family: <?php echo $fontFamily ?>;
        font-weight: bold;
        text-decoration: none;
        color: #A0A0A0;
}

h1,h2,h3 {
        color: <?php echo $prefs['TitleTextColor'] ?>;
        font-family: "Helvetica","Arial","Ms Sans Serif";
}

h1 {
        font-size: 14px;
        margin-top: 10px;
        margin-bottom: 0px;
        margin-left: 16px;
}

h2 {
        font-size: 12px;
}


/* FORM widgets common properties */
input,select,textarea,button {
        font-family:  <?php echo $fontFamily ?>;
        font-size: <?php echo $baseFontSize ?>;
        border: 1px solid gray;
}

/* Small,Medium,Large inputs */
.inpS {
        width: 65px;
}
.inpM {
        width: 150px;
}
.inpL {
        width: 200px;
}

/* Small Medium, Large Buttons */
.btnS {
        border: 1px outset white;
        width: 40px;
}
.btnM {
        border: 1px outset white;
        width: 60px;
}
.btnL {
        border: 1px outset white;
        width: 100px;
}

/** UNDER WORK */

th {
        font-family: "Helvetica", "Ms Sans Serif", "Sans serif";
        font-size: 12px;
}

td {
        font-family: <?php echo $fontFamily ?>;
        font-size: <?php echo $baseFontSize ?>;
}

.error {
        font-family: <?php echo $fontFamily ?>;
        font-size: 12px;
        font-weight: bold;
        color: red;
}



.tooltip {
        font-family: <?php echo $fontFamily ?>;
        font-size: 10px;
        color: #234567;
        background-color: #ffffcc;
        border-color: #000000;
        border-style: solid;
        border-width: 1px;
        overflow: hidden;
        padding: 10px;
        position: absolute;
        visibility: hidden;
}

/* the top navbar */
#navbar {
        border-bottom: 1px solid gray;
}

/* the top navbar */
#subnavbar {
        background-color: <?php echo  $prefs['altBgColor'] ?>;
}

.hoverBtn {
        border-width: 1px;
        border-style: transparent;
}

.hoverBtn:hover {
        border: 1px outset white;
}

/* widgets embedded in subnavbar */
.navbarWidget { color:white;background-color:<?php echo  $prefs['altBgColor'] ?>;height:18px;font-weight:bold;font-size:inherit; }

CAPTION.formCaption {
        border-bottom:1px solid #bcbcbc;
        color: <?php echo $prefs['PageTextColor'] ?>;
        text-align:left;
        font-size: <?php echo $baseFontSize ?>;
        font-weight:bold;
}


/**************************** calendar views styles */

/* height is calculated in module (mod.day,...) */
TD.hourSplice {
        border-bottom: 1px solid #ddd;
}


DIV.dayEvent {
        position:absolute;
        background-color: #bbddbb;
        border: 1px solid black;
        margin: 0;
}


DIV.weekEvent {
        margin-top: 2px;  padding-left:3px;  width:90%;  vertical-align: top;
        border-left:1px solid slateblue;  cursor: pointer;
}

DIV.weekTodo {
        margin-top: 2px;padding-left:3px;vertical-align: bottom; cursor: pointer;
}

PRE {
        font-size: 8px;
}
