<?php

/*********************** GLOBAL CONFIG */
/*
        webo installation root directory
*/
$baseDir = "/home/webspace/webo";

/*
        webo base URL, without the  trailing /
        http://www.company.com/weborganizer
*/
$WEBO_URL = "http://$HTTP_SERVER_VARS[HTTP_HOST]/webo";


/*
        authentication method to use - *internal method only supported for now*
        internal : Webo authentication page
        http : Standard HTTP authentication with a popup dialog
*/
$LOGIN_METHOD = 'internal';


/*
Webo database URL
url format is mysql://[username]:[password]@[host]/[databasename]
eg. mysql://weboaxs:secret@localhost/webo
*/
$DB_URL = "mysql://userid:passwd@localhost/webo";

/*
   a directory used to store temporary or cached file
   must be :
    - persistent ( regulary emptied /tmp may be a bad idea)
    - writable by user running the Web server
    - large enough ( free space around 20Mb for a 100 users webo)
   to create it (assuming your webserver group is www-data )
   # mkdir /var/tmp/webo
   #chmod g+rw /var/tmp/webo
   #chgrp www-data /var/tmp/webo
*/
$CACHE_DIR = '/var/tmp/webo';

/*
        language as country code (dummy but temporary) : fr,uk
        supported languages : fr, uk only yet
*/
$LANG = "uk";

/*
where to store log messages :
        db : use the webolog table in webo database
        syslog : use the system logger (syslog method)
*/
isset($LOG_METHOD) or $LOG_METHOD = 'syslog';
// logging minimal level
isset($LOG_LEVEL) or $LOG_LEVEL = LOG_DEBUG;


// PHP's most hated "features"
// TODO : die if it is set On set_magic_quotes_runtime(0);
// $ret = ini_set("magic_quotes_gpc",0);
set_magic_quotes_runtime(0);

// session last 100 hours
ini_set("session.cache_expire", 6000 );


/****YOU SHOULDNT HAVE TO EDIT BELOW THIS POINT ********************/

/*
        this map associate an object ($O parameter) with a script
        path must be under modules/ directory
*/
$class_registry = array(
        "authent" => "authent/index",
        "desktop" => "desktop/index",
        "abook" => "abook/index",
        "tasks" => "tasks/index",
        "contact" => "abook/contact/index",
        "calendar" => "calendar/index",
        "event" => "calendar/event/index",
        "todo" => "tasks/index",
        "note" => "notes/index",
        "config" => "config/index",
        "news" => "webspider/index",
        "webspider" => "webspider/index",
        // admin tasks
        "admin" => "admin/index",
        "user" => "admin/user/index",
        "group" => "admin/index",
);




/*********************** SOFTWARE INFORMATIONS */

$WEBO_VERSION = "1.0";
$WEBO_HOMEPAGE = "http://sourceforge.net/projects/webo";


?>
