<?php
/*
        this page is  the entry point for the whole application,
        it provides libraries includes, initializations, authent checking
        and preliminary action decision, based on $O parameter (target Object)
*/

$ret =  @include( "./webo.conf.php" );

if( ! $ret )
        die( "Missing configuration file webo.conf.php" );

// general HTML presentation and misc. functions
include_once( "./lib/utils.php" );
// database connectivity (abstraction layer)
include_once( "./lib/db/db.mysql.php" );
// date manipulation class
include_once( "./lib/date/date.php" );
// Webo desktop
include_once( "./lib/webo/Desktop.php" );
// Webo calendar (an advanced event container)
include_once( "./lib/webo/Calendar.php" );
// Webo todos container
include_once( "./lib/webo/TaskList.php" );
// Webo address book component
include_once( "./lib/webo/AddressBook.php" );
// Webo context
include_once( "./lib/webo/Webo.php" );
// User bean
include_once( "./lib/webo/User.php" );
// http headers utility
include_once( "./lib/http.php");

http_no_cache();

// open a connection to the database
db_connect($DB_URL);


/////////////////////////////////// date & calendar shared stuff
// TS = timestamp
intval(@$TS ) || $TS = time();
$dat = getdate( $TS );
$date = new Date( $TS );

// time . format hh:mm
if( isset( $T ) ) {
   echo( "T is still used:remove that" );
}

$today = getdate( time() );

session_start();

/////////////////////////////////// authent verifications
if( isset($_logout) ) {
   include( "./signin.php" );
}


//// @hack Containers that are not session-persisted must be instanciate here

$desktop = new Desktop();
// HACK !
if( @is_object($user) ) 
{
   $tasklist = new TaskList( $user );
}

if( @$O == "dump" ) /// debug stuff - must be before cancel for obvious reasons
{
   include "./modules/base/dump.php";
   exit();
}

// TODO remove these actions from here
if( isset($_cancel) or isset($_return) )
{
   HistoryBack();
}


isset($O) or $O = "desktop";

$handler = @$class_registry[$O];

if( $handler == NULL ) {
   die( "unhandled class $O" );
}
else {
   include( "./modules/$handler.php" );
}


?>
