<?php

class Checkbox
{

	function Checkbox( $name, $value="", $status = false, $options="" )
	{
		$this->name = $name;
		$this->value = $value;
		$this->options = $options;
		$this->widgetClass = "checkbox";
		$this->widgetFamily = "box";		
		$this->Checked( $status );
	}
	
	function Checked( $status )
	{
		if( $status )
			$this->checked = "checked";
		else
			$this->checked = "";
	}

	// add a property to the widget ( ex: "size=20" )
	function addOption( $htmlcode )
	{
		$this->options .= " " . $htmlcode;
	}
	
	function toString()
	{
		$this->fmt = '<input type="%s" name="%s" value="%s" %s %s>';
		return sprintf( $this->fmt, $this->widgetClass, $this->name, $this->value, $this->checked, $this->options );
	}	
		
}

class CheckboxGroup
{

	function CheckboxGroup( $name, $currentvalues, $setOfValues, $options="", $useHash=true )
	{
		$this->name= $name;
		if( is_array($currentvalues))
			$this->currentValues = $currentvalues;
		else
			$this->currentValues = array($currentvalues);
		$this->options = $options;
		$this->_values = array();
		$this->setValues( $setOfValues );
		$this->useHash( $useHash );
	}
	
	function setValues( $setOfValues )
	{
		if( ! is_array( $setOfValues ) )
			return false;
		$this->_values = $setOfValues;
	}

	// add a property to the widget ( ex: "size=20" )
	function addOption( $htmlcode )
	{
		$this->options .= " " . $htmlcode;
	}
	
	function useHash( $boolean ) 
	{
		$this->useHash = $boolean; 
	}	

	function toString()
	{		
		// radio separator, eg <br> or whitespaces
		if( empty($this->sep) )
			$this->sep = "&nbsp;&nbsp;&nbsp;";
		$ret = "";
		
		if( ! is_array( $this->_values ) )
			return $ret;
		
		while( list($k,$v) = each( $this->_values ) ) {
			( ! $this->useHash ) && $k=$v;
			if( in_array($k,$this->currentValues) )
				$sel = "checked";
			else
				$sel = "";
			$ret .= "<input type=\"checkbox\" name=\"$this->name\" value=\"$k\" $sel $this->options> $v $this->sep";
		}
		return $ret;
	}

		
}

?>
