<?php

class MenuItem
{
   var $style = 'icontext';

   function MenuItem( $url, $caption, $icon="", $target="", $shortcut="", $disabled = 0 )
   {
       global $fmtImgLink, $WEBO_URL;

       $this->options = "";

       // hack for javascript handler
       if( preg_match( "/^javascript:(.*)/i", $url, $regs  ) ) {
           $this->url = "";
           $this->options .= " onclick=\"$regs[1]\"";
       } else {
           $this->url = $url;
       }

       $this->caption = $caption;
       $this->disabled = $disabled;

       if( $icon )
           $this->img = sprintf( "<img align=center src=\"$WEBO_URL/img/%s.gif\" alt=\"%s\" border=0>", $icon , "" );
       else
           $this->img = "";

       if( $target ) $this->options .= " target=\"$target\"";

       if( $shortcut ) $this->options .= " accesskey=\"$shortcut\"";
   }

   function setStyle( $style )
   {
      $this->style = $style;
   }

   function toString()
   {
      if( $this->style == "icon" )
         return $this->toIcon();
      if( $this->disabled ) {
         return "$this->img<br><span class=\"disabled\">$this->caption</span>";
      } else {
         return "<a class=\"menu\" href=\"$this->url\" $this->options>$this->img<br>$this->caption</a>";
      }
   }

   /*!
      return HTML code for a compact version without texte ( only the icon)
   */
   function toIcon()
   {
      if( $this->disabled ) {
         return $this->img;
      } else {
         return "<a class=\"menu\" href=\"$this->url\" $this->options>$this->img</a>";
      }
   }

   function toVertical()
   {
       $out = "";
       if( $this->disabled ) {
           $out .= $this->img . "&nbsp;<span class=\"disabled\">" . $this->caption . "</span><br>";
       } else
           $out .= "<a class=\"menu\" href=\"$this->url\" $this->options>" . $this->img . "&nbsp;" . $this->caption . "</a><br>";
       return $out;
   }


   } // class MenuItem


   /*

   Collection of items
   specialization: display a toolbar usually composed of image+text buttons (class MenuItem)

   */

class NavBar
{
   var $options = "";
   var $disposition = "horizontal";
   var $itemWidth = "55"; // dimension of a button in the menu in pix

   function addOption( $options )
   {
       $this->options .= " $options";
   }

   function addItem( &$obj, $insert=false)
   {
      // append mode : icon is placed at end of navbar
      if( ! $insert ) {
         $this->items[] = $obj;
      // insert mode: icon is placed in the first "slot" of navbar
      } else  {
         array_unshift( $this->items, $obj );
      }
   }


   function toString()
   {
       $out = "";
       if( $this->disposition == "horizontal" ) {
           $out .= "<tr>";
       }
       for( $i=0; $i<count($this->items); $i++ )
       {
           if( $this->disposition == "vertical" ) {
            $out .= '<tr><td height="'. $this->itemWidth. '" valign="bottom" align="left" >';
            $out .= $this->items[$i]->toString();
            $out .= "</td></tr>\n";
           } else {
            $out .= '<td width="' . $this->itemWidth . '" valign="bottom" align="center">';
            $out .= $this->items[$i]->toString();
            $out .= "</td>\n";
           }
       }
       if( $this->disposition == "horizontal" ) {
           $out .= "</tr>\n";
       }
       return $out;
   }

   }

   ?>
