<?php

/*
	Simple menu item ( without children )
*/

$SELF_URL = $PHP_SELF;

$TreeItem_dirIcon = "$baseUri/img";

class TreeItem
{
	var $iconType = "gif";
	var $defaultIcon = 'blk';
	var $defaultTarget = 'admmain';
	var $dirIcon;
	var $iconWidth = "16";
	var $iconHeight = "16";

	function set( $prop, $value ) {
		$this->$prop = $value;
	}
	
	function TreeItem( $label, $url, $target="", $icon="", $options=""  )
	{
	
		$this->label = $label;
		$this->url = $url;
		$this->dirIcon = $GLOBALS['TreeItem_dirIcon'];
		
		if( $icon == "" )
			$this->icon = $this->defaultIcon;
		else
			$this->icon = $icon;

		$this->options = $options;
		
		if( $target != "" )
			$this->options .= ' target="' . $target . '"';
	}
	
	function Display()
	{
		$icon = "$this->dirIcon/$this->icon.$this->iconType";
		printf( '<img src="%s"> <a href="%s" %s>%s</a>', 
			$icon, $this->url, $this->options, $this->label );
		echo "<br>\n";
	}
	
}



/***********
 *
 * Menu Node than can have children entries
 *
 **********/

class TreeFolder extends TreeItem
{

	var $items;
	var $defaultIcon   = 'obj/folder';	// icon to display in front of opened item
	var $imgChild = '<img src="/adm/icons/.gif">'; // linker to a child TODO
	var $imgSpacer = '<img src="%s/blk.gif" height="1" width="%s">'; // image used as spacer - should be a transparent gif W/H 20/1
	var $_expand = false;
	
	function TreeFolder( $label, $url="", $target="", $icon = "", $id="", $options=""  ) 
	{

		if( $id == "" ) $id = $label;
		if( $icon == "" ) $icon = $this->defaultIcon;

		$this->TreeItem( $label, $url, $target, $icon, $options );
		
		$this->id = $id;
// ??		$this->obj = $obj;
		$this->items = array();
	}

	function add( $obj ) {
		
		if (is_object($obj)) {
//			echo "$this->label::add( $obj->label ( $obj->id ) \n<br>";
			$this->items[] =& $obj;
				
		} 
	}

	function &getChild( $id ) 
	{
		for( $i=0; $i<count($this->items); $i++ ) {
			if( is_object($this->items[$i]) and $this->items[$i]->id == $id )
				return $this->items[$i];
		}
		return false;
	}
	
	function expandAll()
	{
//		echo "$this->label::expandAll()<br>";
		$this->expand();
		$this->_parsetree( "expandAll" );
	}

	// can be overlaoded ( eg. dynamic loading of child nodes)
	function expand()
	{
//		echo "TF.expand()<br>";
		$this->_expand = true;
	}
	
	function _parseTree( $callback )
	{
		
		// children parse 
		for( $i=0; $i<count($this->items); $i++ ) {
			if( is_object($this->items[$i]) ) {
				@$this->items[$i]->$callback();
			}
		}
					
	}
		
	function Display( $nest = 0 ) {

		$urlID = urlencode( $this->id );
		
		global $SELF_URL, $QUERY_STRING, $HTTP_GET_VARS;

		if ($nest) {
			$marginwidth = $nest * $this->iconWidth;
			$margin = sprintf( $this->imgSpacer, $this->dirIcon, $marginwidth );
		} else { 
			$margin = "";
		}


		if ( isset($HTTP_GET_VARS['tp']) && isset($HTTP_GET_VARS['tp'][$this->id]) ) {
//			echo "$this->id.expand()<br>";
			$this->expand();
		}
		
		if( $this->_expand == true ) {

			$pattern = "tp[$urlID]=1&";
			$new_query = str_replace( $pattern, '', $QUERY_STRING );
			
			$nodeURL = $SELF_URL . "?" . $new_query;
			$this->TreeItemDisplay( $nodeURL );

			// display children items
			for( $i=0; $i<count($this->items); $i++ ) {
				
				print $margin;
				printf( $this->imgSpacer, $this->dirIcon, $this->iconWidth );
				
				if( is_object($this->items[$i]) ) {
					$this->items[$i]->Display( $nest + 1 );

				}
			}
			
		} else {
			
			$nodeURL = $SELF_URL . "?tp[$urlID]=1&" . $QUERY_STRING;
			$this->TreeItemDisplay( $nodeURL );
		}
	}
	
	function TreeItemDisplay( $nodeURL )
	{
		$icon = "$this->dirIcon/$this->icon.$this->iconType";
		
		if( $this->url == "" ) {
			printf( '<a href="%s"><img border=0 src="%s"></a> %s', 
			$nodeURL, $icon, $this->label );
			
		} else {
			printf( '<a href="%s"><img border=0 src="%s"></a> <a href="%s" %s>%s</a>', 
			$nodeURL, $icon, $this->url, $this->options, $this->label );
		}
		echo "<br>\n";
		
	}
	
	
}


?>
