<?php
/*

Smart file / webpage caching utility

*/


class file_cache
{

	var $cachedir = "/tmp/filecache"; // where to store cache data

function file_cache( $cachedir = NULL )
{
   if( $cachedir != NULL )
      $this->setCacheDir($cachedir); // to auto create it
}

function _getfilename( $key )
{
	if( preg_match( "/\.(\w{1,8})$/", $key, $reg))
		$ext = $reg[1];
	else
		$ext = "unk";
	$md5 = md5($key);
	$file = $this->cachedir . "/" . $md5 . ".$ext";
	return $file;
}


function storeUrl( $url  )
{
  $fp = fopen( $url, "r" )
     or die( "cache.storeUrl : no such ressource or URL [$url]" );
  $data = "";
  while( !feof($fp)) {
  	$data .= fread( $fp, 1024 );
  }
  fclose($fp);
	return $this->put( $url, $data );
}


function put( $key, $data )
{
	$file = $this->_getfilename( $key );
	$fp = fopen( $file, "w" );
	fwrite( $fp, $data );
	fclose($fp);
	chmod( $file, 0664 );
	chgrp( $file, 'www-data' ); // TODO : customized groupname
	return true;
}


function getData( $key )
{
	$file = $this->_getfilename( $key );
	if( ! file_exists($file)) {
	   echo "no file found for $key";
		return NULL;
	}
	$fp = fopen( $file, "r" );
	$data = fread( $fp, filesize($file));
	fclose($fp);
	return $data;
}

function getLocalFile( $key )
{
	$file = $this->_getfilename( $key );
	if( ! file_exists($file) )
		return NULL;
	else
		return $file;
}

function setCacheDir( $dir )
{
	if( ! is_dir($dir)) {
		$ret = mkdir( $dir, 0755 ); // better mode ?
		if( ! $ret )
			die( "file_cache.setCacheDir : failed to create cache dirtectory [$dir]");
	}
	$this->cachedir = $dir;
}


function listCacheContent()
{
	$list = array();
	$fd = opendir($this->cachedir);
	while( $file = readdir($fd) ) {
		if( $file == "." or $file == ".." )
			continue;
		$list[] = $file;
	}
	return $list;
}

function getCacheDir()
{
	return $this->cachedir;
}


/*! 
	TODO
*/
function refresh( $key )
{
	
}

}



?>
