<?php
/*

	@depends LDCom/Utils/logger.php

*/

class file_csv_reader
{
	/****************
	 * ces variables sont *private*
	 ***************/

	var $filename; 		// nom du fichier temporaire
	var $filename_user;	// nom du fichier utilisateur
	var $valide;		// true si fichier valide, false sinon
	/// le descripteur du fichier
	var $fo = NULL;

	/// le caractere de separation des champs
	var $separator = ";";

	/// numero de ligne courant
	var $linenumber = 0;

	/// nombre de champs sur chaque ligne
	var $fieldcount = 0;

	var $verifyColumnsCount = true;

	/// politique a appliquer pour les champs dquoted entre double-quotes (")
	var $dblQuotePolicy = 'ignore';

	function file_csv_reader( $filename, $separator = ";" )
	{
		$this->filename = $filename;
		$this->separator = $separator;
		$this->transformers = array();
		$this->valide = true;
		$this->linenumber = 0;
		$this->fo = fopen( $this->filename, "r" )
			or die( "no such file $filename" );
		$this->firstseekpos = ftell($this->fo);
	}
	

	function getFieldnamesFromLineOne( $callback = NULL )
	{
		$line = chop(fgets($this->fo));
		if( ! $line )
			return NULL;		
		$fieldnames = split( $this->separator, $line );
		foreach($fieldnames as $idx => $name ) {
			isset($callback) && $name = $callback($name);
			$this->addFieldDescriptor($idx, $name );
		}
		$this->firstseekpos = ftell($this->fo);
	}
	
	function fieldCount()
	{
		return count($this->fields);
	}
	
	/*!
		definition de la politique de gestion des champs doubles quots :
		@param policy string la methode a employer :
		   - auto : detecte automatiquement les " et les vire
		   - always : retire systematiquement les dbl quote, issue un warning si le champ n'en possede pas (NIY)
		   - ignore (defaut) : ne detecte pas les quotes 
	*/
	function doubleQuoteRemove( $policy = "auto"  )
	{
		$this->dblQuotePolicy = $policy;
	}


	// just an alias 
	function getFieldnamesFromFile( $callback = NULL )
	{
		$this->getFieldnamesFromLineOne( $callback );
	}
	
	function getFieldIndex( $name )
	{
		$idx = array_search( $name, $this->fields ); 
		if( $idx === false )
			return NULL;
		else
			return $idx;
	}

	function getFieldMap()
	{
		return $this->fields;
	}

	/*!
	 *
	 */
	function addFieldDescriptor( $column, $fieldname )
	{
		log_debug( "addFieldDescriptor( $column, $fieldname )" );
		$this->fields[$column] = $fieldname;
		$this->fieldcount ++;
	}

	function addFieldTransformer( $fieldname, $cbFunction )
	{
		$this->transformers[$fieldname] = $cbFunction;
	}
	
	/*******************
	* Valide si extention .CSV
	*******************/
	function isValideCsv(){
		if( (substr($this->filename_user,-4))<>'.csv') $this->valide = false;
		return $this->valide;
	}
	
	/*******************
	* Valide le nbr de colone sur une ligne
	********************/
	function isValideCol(){
		do {
	   	$line = fgets( $this->fo );
			$this->linenumber ++;
			if( ! $line ) return NULL;
                } while( trim($line) == "" );
		$this->currentRecord = split( $this->separator, $line );
		if( count($this->currentRecord) != $this->fieldcount ) {
		  $this->valide = false; //fichier invalide
		  echo "Warning: wrong field number (". count($this->currentRecord) .") in ".$this->filename_user.", line  $this->linenumber";
		}		 
	}
	
	/***********
	* renvoi fin de fichier
	***********/
	function eof()
	{
		return feof( $this->fo );
	}
	
	/****
	* remplacement des accents pas equiv ascii
	****/

		
	/****************
	* Index de sequence : fct_csv.
	****************/
	function getNextCSVId()
	{
		$query = 'SELECT nextval(\'fct_csv\')';
		$array = db_list( $query );
		$sequence = $array[0]['nextval'];
		return $sequence;
	}

	/****************
	* Index de sequence : fct_file.
	****************/
	function getNextFILEId()
	{
		$query = 'SELECT nextval(\'fct_file\')';
		$array = db_list( $query );
		$sequence = $array[0]['nextval'];
		return $sequence;
	}
	
	/******************
	* Sauvegarde ds la base
	* Insert chaque ligne ds la base
	******************/
	function SaveFileRowInBase($FILEId)
	{
		global $conn;
		/* Recup puis split ligne   */
		do {
	        	$line = fgets( $this->fo );
			$this->linenumber ++;
			if( ! $line ) return NULL;
                	} while( trim($line) == "" );
                	$line = trim($line);
		$this->currentRecord = split( $this->separator, $line );
		$hash = array();
		foreach( $this->fields as $idx => $name )
			{
			$hash[$name] = trim( $this->currentRecord[$idx]);
		}
		$ndir = $this->currentRecord[0];
		$num = $this->currentRecord[1];
		$voie = $this->currentRecord[2];
		$adresse = $this->currentRecord[3];
		$idcode = $this->currentRecord[4];
		$commune = $this->currentRecord[5];
		$commune = $this->normalizeCommune($commune);
		$valdebit = $this->currentRecord[6];
		$CSVId = $this->getNextCSVId();
		/* insert row */
		$queryINSERT = 'INSERT INTO "PST_CSVIMPORT" ("ID_CSVROW","ID_CSVFILE","CP_CSV","COM_CSV","DEBIT","STATUS","NDIR","NUM","VOIE","ADRESSE") VALUES (\''.$CSVId.'\',\''.$FILEId.'\',\''.$idcode.'\',\''.$commune.'\',\''.$valdebit.'\',\'SB\',\''.$ndir.'\',\''.$num.'\',\''.$voie.'\',\''.$adresse.'\')';
		$pgquery = db_query($queryINSERT);
	}
	
	/******************
	* Sauvegarde ds la base
	* Save le fichier ds la base
	******************/
	function SaveFileInBase($FILEId, $numrowFile)
	{
		global $conn;
		//echo "<pre>"; print_r( $CSVId ); echo "</pre>"; 
		$queryINSERT = 'INSERT INTO "PST_CSVFILE" ("ID_CSVFILE","NAME_FILE","ID_USER","NUMROW","STATUS") VALUES (\''.$FILEId.'\',\''.$this->filename_user.'\',\''.$this->iduser.'\',\''.$numrowFile.'\',\'SB\')';
		//echo $queryINSERT;
		//$conn = db_open();
		$pgquery = db_query($queryINSERT);
	}
	
	function lineNumber()
	{
		return $this->linenumber;
	}
	
	/*
		lit l'enregistrement suivant du fichier CSV (ligne suivante)
		renvoie le hash des valeurs indexees par leur nom
	*/
	function read()
	{
		do {
			$line = trim(fgets($this->fo));
			log_debug( "line=$line" );
			$this->linenumber ++;
			if( feof($this->fo))
				return NULL;
		} while( $line == "" );
		
		$this->currentRecord = split( $this->separator, $line );
		if( ( $this->verifyColumnsCount ) && (count($this->currentRecord) != $this->fieldcount ) ) {
			echo "warning: wrong field number (" . count($this->currentRecord) . ") in $this->filename, line  $this->linenumber \n";
		}
				
		$hash = array();
		foreach( $this->fields as $idx => $name )
		{
			
			if( isset($this->currentRecord[$idx]) && ($this->dblQuotePolicy == 'auto') && ( substr($this->currentRecord[$idx],0,1) == '"') ) {
				$this->currentRecord[$idx] = substr($this->currentRecord[$idx],1,-1 ); 
				log_error( "processed dquoted field removal : " . $this->currentRecord[$idx]  );
			}
			/* if there is a data transform hook function, we call it */
			if( isset($this->transformers[$name]) ) {
				$cb = $this->transformers[$name];
				$hash[$name] = $cb( $this->currentRecord[$idx] );
			} else {
				$hash[$name] = @$this->currentRecord[$idx];
			}
		}
		return $hash;
	}

	function rewind()
	{
		fseek($this->fo, $this->firstseekpos);
	}	
		
	/******************
	* Fermeture du fichier encour de lecture
	******************/
	function close()
	{
		if( $this->fo ) {
			fclose( $this->fo );
			$this->fo = NULL;
		}
	}
	
} // end class File_CSV

?>
