<?php

/*

USAGE

   include("lib/file/rss/reader.php");
   $file = $argv[1];
   $xml = new file_rss_reader( $file );
   print_r( $xml->getitems() );
   
*/

class file_rss_reader
{
   var $xml = NULL; // the xml parser hanlder

   function file_rss_reader( $filename )
   {
      $this->file = $filename;
      $this->fields = array();
      $this->items = array();
      $this->parse( $this->file );
      $this->itemCount = count($this->items);
      $this->position = 0; // current item
      
   }

   function getFieldMap()
   {
      return $this->fields;
   }

   function getItems()
   {
      return $this->items;
   }

   function parse( $file )
   {
      $this->xml = xml_parser_create();
      xml_set_object( $this->xml, $this );
      xml_set_element_handler( $this->xml, "stag", "etag" );
      xml_set_character_data_handler( $this->xml,"cdata");
			$this->state = 'parsing';
			
      $fp = fopen( $file, "r" )
         or die( "no such file $file" );
      $data = "";
      while( !feof($fp)) {
      	$data .= fread( $fp, 1024 );
      }
      fclose($fp);
      xml_parse($this->xml, $data ) ;
      xml_parser_free( $this->xml );
      $this->state = 'loaded';
      unset($this->_cdata);
      unset($this->_item);
}

   function stag( $parser, $tag, $attribs )
   {
      $tag = strtolower(preg_replace( "/^(.*:)/", "", $tag));
//      echo "stag( $tag, $attribs )\n";
      if( $tag == 'item' ) {
         $this->state = 'item';
         $this->_item = array();
      }
   }

   function cdata( $p, $data )
   {
      $this->_data = $data;
   }

   function etag( $parser, $tag )
   {
      $tag = strtolower(preg_replace( "/^(.*:)/", "", $tag));
      if( $tag == 'item' ) {
         $this->items[] = $this->_item;
         $this->state = 'other';
         return;
      }
      if( $this->state == 'item') {
         if( ! in_array( $tag,$this->fields))
            $this->fields[] = $tag;
         $this->_item[$tag] = $this->_data;
         
      }
   }

} // class


?>
