<?php
/*!
   A vcard file generator
   @implements  file_writer
   
*/

class file_vcard_writer
{
   var $linesep = "\r\n";
   
   function file_vcard_writer()
   {
      $linesep = $this->linesep;
      $this->fieldsMap = array();
      $this->vcardHead = "BEGIN:VCARD" . $linesep. "VERSION:2.1" . $linesep;
      $this->vcardFoot = "END:VCARD" . $linesep;
   }

   function getContentType()
   {
      return "text/x-vcard";
   }

   function openFile( $filename, $mode='w' )
   {
      $this->fo = fopen($filename, $mode );
   }

   function closeFile()
   {
      $this->fo && fclose($this->fo);
   }

   function setGetter( $methodname )
   {
      $this->cbGetter = $methodname;
   }

   function addFieldDescriptor( $vcardProp, $externalProperty )
   {
      $this->fieldsMap[$vcardProp] = $externalProperty;
   }

   /*!
      write a hash array in the file stream
      hash keys are mapped automagically according to our fieldsMap
   */
   function write( $h )
   {
      // TODO when object writer is done and fiable
   }

   /*!
      write a object array in the file stream
      object properties are accessed through a getter method defined in setGetter( methodName )
      mapping must also be defined
   */
   function writeObject( $obj )
   {
      $cb = $this->cbGetter;
      if( ! $cb ) die( "file_vcard_writer : no getter defined (fatal)" );
      $tpl = $this->vcardHead;
      foreach( $this->fieldsMap as $idx => $property )
      {
         $value = $obj->$cb( $property );
         
         if( $value != NULL ) {
            // special encoding calls
            if( $idx == 'NOTE' ) {
               $value = $this->qp_encode( $value );
               $idx .= ";ENCODING=QUOTED-PRINTABLE";
            }
            $tpl .= "$idx:$value" . $this->linesep;
         }
      }
      $tpl .= $this->vcardFoot;
      // TODO : write call
      return $tpl;
   }

   function qp_encode( $input, $line_max = 76) 
   { 
      $hex = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'); 
      $lines = array( $input );
      $eol = "\r\n"; 
      $escape = "="; 
      $output = ""; 
      while( list(, $line) = each($lines) ) 
      { 
         //$line = rtrim($line); // remove trailing white space -> no =20\r\n necessary 
         $linlen = strlen($line);
         $newline = "";
         for($i = 0; $i < $linlen; $i++) { 
            $c = substr($line, $i, 1); 
            $dec = ord($c); 
            // echo "c=$c dec=$dec\n";
            if ( ($dec == 32) && ($i == ($linlen - 1)) ) { // convert space at eol only 
               $c = "=20"; 
            } elseif ( ($dec == 61) || ($dec < 32 ) || ($dec > 126) ) { // always encode "\t", which is *not* required 
               $h2 = floor($dec/16); $h1 = floor($dec%16); 
               $c = $escape.$hex["$h2"].$hex["$h1"]; 
            } 
            if ( (strlen($newline) + strlen($c)) >= $line_max ) { // CRLF is not counted 
               $output .= $newline.$escape.$eol; // soft line break; " =\r\n" is okay 
               $newline = ""; 
            } 
            $newline .= $c; 
         } // end of for 
         $output .= $newline . $eol;
      } 
      return trim($output);
   } 


}

?>