<?php
/*!
   http protocol utilities
   provides some shortcuts utilities to usefull HTTP control directives about
   document expiration, cache control directives

    $Log: http.php,v $
    Revision 1.2  2003/03/20 01:23:46  lwest
    added expires and date methods


*/

/*!
   tell the browser to cache the page during a given time
   @param cachePrivacy	the type of cache : public wil cache the page on proxy, private on browser only
*/
function http_cache_for( $cachePrivacy, $time_in_seconds = 600 )
{
   $dtHttp = gmstrftime( "%a, %d %b %Y %H:%M:%S GMT", time() + $time_in_seconds );
   header( "Expires: $dtHttp" );
   header( "Cache-Control: $cachePrivacy, max-age=$time_in_seconds" );
   header( "Pragma: foo");
}

function http_expires( $time_in_seconds = 600 )
{
   $dtHttp = gmstrftime( "%a, %d %b %Y %H:%M:%S GMT", time() + $time_in_seconds );
   header( "Expires: $dtHttp" );
}

function http_date( $timestamp )
{
   return gmstrftime( "%a, %d %b %Y %H:%M:%S GMT", $timestamp );
}

function http_no_cache()
{
   $dtHttp = gmstrftime( "%a, %d %b %Y %H:%M:%S GMT", 1 );
   header( "Expires: $dtHttp" );
   header( "Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0" );
   header( "Pragma: no-cache");
}


?>
