<?php
/*

  A class to safely manipulate URLs
  - should be enhanced

  $Id: URL.php,v 1.1 2003/05/18 07:42:28 lwest Exp $

*/

class net_URL
{

  function net_URL( $url="" )
  {

    $this->urlinfo = array();
    if( $url != "" ) {
      $this->Parse( $url );
    }
  }

  function parse( $url )
  {
    $info = parse_url( $url );
    if( ! is_array($info))
      return;
    $this->urlinfo = $info;
  }

  function getScheme() {
    return $this->urlinfo['scheme'];
  }

  function getHost()
  {
    return $this->urlinfo['host'];
  }

  function getPort()
  {
    return $this->urlinfo['scheme'];
  }

  function getPath()
  {
    return $this->urlinfo['path'];
  }

  function getQuery()
  {
    return $this->urlinfo['query'];
  }

  function getFragment()
  {
    return $this->urlinfo['fragment'];
  }

  function getUser()
  {
    return $this->urlinfo['user'];
  }

  function getPassword()
  {
    return $this->urlinfo['pass'];
  }

  function setQuery( $query )
  {
    $this->urlinfo['query'] = $query;
  }

  function setUser( $username )
  {
    $this->urlinfo['user'] = rawurlencode($username);
  }

  function setPassword( $pass )
  {
    $this->urlinfo['pass'] = rawurlencode($pass);
  }

  function setScheme( $pass )
  {
    $this->urlinfo['scheme'] = strtolower($scheme);
  }

  // build and return the url
  function url()
  {

    if( $this->urlinfo['scheme'] )
      $url = $this->urlinfo['scheme'] . "://";

    if( $this->urlinfo['user'] ) {
      if( $this->urlinfo['pass'] )
        $url .= $this->urlinfo['user'] . ":" . $this->urlinfo['pass'] . "@";
      else
        $url .= $this->urlinfo['user'] . "@";
    }

    if( $this->urlinfo['host'] )
      $url .= $this->urlinfo['host'];

    if( $this->urlinfo['port'] )
      $url .= $this->urlinfo['port'];

    if( $this->urlinfo['path'] )
      $url .= $this->urlinfo['path'];

    if( $this->urlinfo['query'] )
      $url .= "?" . $this->urlinfo['query'];

    if( $this->urlinfo['fragment'] )
      $url .= "#" . $this->urlinfo['fragment'];

    return $url;

  }

}


?>
