<?php

/*!
        utils.php
        misc. utilities library for HTML rendering & display

*/


function HistoryBack()
{
        global $webo;

        if( ! empty($webo->urlBack)) {
                $returnUrl = $webo->urlBack;
        } else {
                $returnUrl = $webo->WEBO_URL . "/index.php";
        }
        header( "Location: $returnUrl" );
}



function Button( $query, $icon, $alt = "" )
{
        global $PHP_SELF, $WEBO_URL;
        static $imgid = "btn0";
        $imgid ++; // not used yet, animation done by capturing events at window level
        $html = "<a href=\"$PHP_SELF?$query\"><img name=\"$imgid\" src=\"$WEBO_URL/img/$icon.gif\" alt=\"$alt\" border=0></a>";

        return $html;
}


/*!
        used in form processing to signal an error ( missing or incorrect field )
        message will be displayed in top of form, and the form field will be focused

*/
function FormError( $errormsg, $fieldname=NULL )
{
        global $formErrorMessage, $formErrorField;
        $formErrorMessage = $errormsg;
        $formErrorField = $fieldname;
        return false;
}

/*
*	debut de page generaliste
*
*/
function PageHead()
{
        global $WEBO_URL, $reload_theme, $pagetimer,$QUERY_STRING;

        $pagetimer = Webo::timer("timer.page $QUERY_STRING" );

        if( @$reload_theme )
                $css = "$WEBO_URL/css/user.php?" . time();
        else
                $css = "$WEBO_URL/css/user.php";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>Webo -  <?php isset($pageTitle) && print $pageTitle; ?></title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        <link rel="stylesheet" href="<?php echo $css ?>" />
        <script language="javascript" src="js/main.js"></script>
</head>

<body bgcolor="white" align="center" topmargin="0" leftmargin="0" marginheight="0" marginwidth="0">
<?php

}

/*!
        (clientside)
        display a message using a javascript snipplet
*/
function JSAlert( $msg )
{
        $escmsg = addcslashes( $msg, "'" );

?>
<script language="javascript">
<!--
        alert( '<?php echo $escmsg?>' );
// -->
</script>
<?php
}


/*!
        (clientside)
        focus the given field on the *first* page form
*/
function JSFormFocus( $fieldname, $formNumber=0 )
{
?>
<script language="javascript">
<!--
        document.forms[<?php echo $formNumber ?>].elements["<?php echo $fieldname ?>"].focus();
// -->
</script>
<?php
}


function PageEnd()
{
        global $msg, $webo, $pagetimer;

        // output a javascript alert if a message as been set
        if( ! empty($msg) )
                JsAlert( $msg );

        if( isset($webo) && ! empty($webo->statusMessage) ) {
                $msg = addcslashes( $webo->statusMessage, "'" );

                ?>
<script language="javascript">
                window.defaultStatus = '<?php echo $msg ?>';
// -->
<script>
                <?php
                unset($webo->statusMessage);
        }

        if( @$webo->debugmode ) {
                include_once( "./modules/base/dump.php" );
        }
        Webo::timer($pagetimer, 'log' );
        ?>
</body>
</html>
        <?php

}


function Url( $url, $caption )
{
        return sprintf( '<a href="%s">%s</a>', $url, $caption );
}

function MailtoLink( $url, $caption=NULL, $maxlen=NULL )
{
        if( $url == "" )
                return "";

        if( $caption == "" )
                $caption = $url;

        if( ($maxlen != NULL) && (strlen($caption) > $maxlen) ) {
                $len1 = round($maxlen/2) -1;
                $len2 = strlen($caption) - $len1 - 2;
                $caption = substr( $caption,0, $len1 ) . "..." . substr($caption, $len2 );
        }
        return sprintf( '<a href="mailto:%s">%s</a>', $url, $caption );
}


function ElemDisplay( $mixed )
{

        // widget - MUST implement Display() method
        if( is_object( $mixed ) ) {

                if( method_exists( $mixed, "tostring" ) )
                        echo $mixed->toString();
                else
                        $mixed->Display();

        // array
        } elseif( is_array( $mixed ) ) {

                for( $i=0; $i< count($mixed); $i++ ) {
                        ElemDisplay( $mixed[$i] );
                }

        // scalar value
        }else {
                echo $mixed, "&nbsp;";
        }
}

function RowDef()
{
        global $CellNum, $CellProps;

        $CellNum = func_num_args();
        for( $i=0; $i< $CellNum; $i++ ) {

                $CellProps[$i] = func_get_arg($i);
        }

}

function RowN()
{
        global $CellNum, $CellProps;

        $nargs = func_num_args();

        echo '<tr>';

        for( $i=0; $i< $nargs; $i++ ) {

                $arg = func_get_arg($i);

                if( isset($CellProps[$i]))
                        echo "<td $CellProps[$i]>";
                else
                        echo "<td>";

                switch( gettype($arg) ) {

                case "object" :
                        ElemDisplay( $arg );
                        break;

                case "array" :
                        ElemDisplay( $arg );
                        break;

                default :
                        if( $arg == "" ) $arg = "&nbsp;";
                        echo $arg; 
                        break;
                }
                echo "</td>\n";
        }
        echo "</tr>\n";

}

function Row1( $content, $options = 'class="form"'  )
{

        echo "<tr><td $options>";
        ElemDisplay( $content );
        echo "</td></tr>\n";
}

function Caption( $text )
{
        return '<span class="caption">' . $text . '</span>';
}


function PageTitle( $title, $subtitle="" )
{
        if( $subtitle != "" )
                return "<h1 style=\"letter-spacing:2px\">$title <font size=-1>> $subtitle</font></h1>";
        else
                return "<h1 style=\"letter-spacing:2px\">$title</h1>";
}


function ToolTip( $id, $text, $options="width:400px" )
{
        global $base_uri;

        // add external javascripts
        JScript_Display( "../js/dhtmllib.js" );
        JScript_Display( "../js/tooltip.js" );

?>
<!-- ToolTip -->
<div id="<?php echo $id ?>" class="tooltip" style="<?php echo $options ?>">
<b><img src="<?php echo $base_uri?>/img/help.gif" border=0 margin="10">Aide</b><p>
<?php echo $text ?>
</div>
<?php

}

function ToolTip_Href( $id, $caption )
{
        return "<a href=\"#\" onClick=\"showToolTip('$id')\" onMouseOut=\"hideToolTip('$id')\">$caption</a>";
}


function IconLink( $url, $iconId, $extra= NULL, $altText=NULL, $target="_self" )
{
   // temporary hack to ease gif to png migration
   if( strpos( $iconId,".png"))
      $image = "img/$iconId";
   else
      $image = "img/$iconId.gif";
   return sprintf( '<a href="%s" target="%s" title="%s" %s><img class=menu src="%s" border=0></a>', $url, $target, $altText, $extra, $image );
}

function TextLimiter( $text, $maxlen, $cutAt='end' )
{
   if( $maxlen && strlen($text) <= $maxlen )
      return $text;
   if( $cutAt == 'end' ) {
      return substr($text,0,$maxlen-3) . "...";
   } elseif( $cutAt == 'middle' ) {
      $len1 = round($maxlen/2) -1;
      $len2 = strlen($text) - $len1 - 2;
      return substr( $text,0, $len1 ) . "..." . substr($text, $len2 );
   } else {
      return "..." . substr($text,-$maxlen+3);
   }

}

function Icon( $iconId, $extra=NULL, $alt=NULL )
{
   // temporary hack to ease gif to png migration
   if( strpos( $iconId, ".png"))
      $image = "img/$iconId";
   else
      $image = "img/$iconId.gif";
   if( $alt )
      return sprintf( '<img src="%s" title="%s" %s border="0">', $image, $alt, $extra );
   else
      return sprintf( '<img src="%s" %s border="0">', $image, $extra );
}


function TextLink( $url, $text, $attributes=NULL )
{
        return "<a href=\"$url\" $attributes>" . $text . '</a>';
}


/*!
   localization function.
   try to tranlsate text in english into current locale. safe failing, this solution prevents the "page with text holes" symptom
   @return translated text on success, original text otherwise
*/
function loc( $text )
{
   //return $text;
   global $profile, $LANG, $VOCAB;

   if( $text == NULL )
      return;

   empty($profile['lang']) && $profile['lang'] = $LANG;

   if( $profile['lang'] == 'en' )
      return $text;

   if( ! isset( $VOCAB)) {
      require_once( "./locales/$profile[lang]/messages.php" );
   }

   if( isset($VOCAB[$text]))
      return $VOCAB[$text];
   else {
      webo::log( "translation missing for [$text] in $profile[lang]", LOG_INFO );
      return $text;
   }
}

?>
