<?php
/*

Contact class encapsulate an Address book contact
   this class is also used to store webo's users personal informations @see User.asContact

VERSION
   $Id: Contact.php,v 1.9 2003/04/30 07:34:41 lwest Exp $

INFORMATIONS
   WEBO Project
   author : Leo West <west_leo@removeme.yahoo.com>

*/


class Contact
{

        function Contact()
        {
                $this->info = array();
        }

        function get( $property )
        {
                $property = strtolower($property);

                switch( $property ) {
                        case "oid":
                                return @$this->oid;
                                break;

                        case "email":
                                if( isset($this->info['email1']))
                                        return $this->info['email1'];
                                elseif( isset($this->info['email2']))
                                        return $this->info['email2'];
                                break;

                        case "workemail":
                                return @$this->info['email1'];
                                break;

                        case "homeemail":
                                return @$this->info['email2'];
                                break;

                        case "workphone":
                                return @$this->info['phone1'];
                                break;

                        case "homephone":
                                return @$this->info['phone2'];
                                break;

                        case "mobilephone":
                                return @$this->info['phone3'];
                                break;

                        case "phone":
                                if( isset($this->info['phone1']))
                                        return $this->info['phone1'];
                                elseif( isset($this->info['phone2']))
                                        return $this->info['phone2'];
                                elseif( isset($this->info['phone3']))
                                        return $this->info['phone3'];
                                break;

                        case "fax":
                                if( isset($this->info['fax1']))
                                        return $this->info['fax1'];
                                elseif( isset($this->info['fax2']))
                                        return $this->info['fax2'];
                                break;

                        case "workfax":
                                return @$this->info['fax1'];
                                break;

                        case "homefax":
                                return @$this->info['fax2'];
                                break;

                        case "workaddress":
                           return $this->getAddress(1);
                           break;

                        case "homeaddress":
                           return $this->getAddress(2);
                           break;

                        case "address": // TODO
                                return "TODO get(address)";
                                break;

                        default:
                                if( isset($this->info[$property]) )
                                        return $this->info[$property];
                                break;
                }
                return NULL;
        }

        function set( $property, $value )
        {
                $property = strtolower($property);
                switch( $property )
                {
                        case "oid":
                                $this->info['oid'] = @$this->oid = $oid;
                                break;

                        case "email":
                        case "workemail":
                                $this->info['email1'] = $value;
                                break;

                        case "homeemail":
                                $this->info['email2'] = $value;
                                break;

                        case "phone":
                        case "workphone":
                                $this->info['phone1'] = $value;
                                break;

                        case "homephone":
                                $this->info['phone2'] = $value;
                                break;

                        case "mobilephone":
                                $this->info['phone3'] = $value;
                                break;

                        case "fax":
                        case "workfax":
                                $this->info['fax1'] = $value;
                                break;

                        case "homefax":
                                $this->info['fax2'] = $value;
                                break;

                        case "homeaddress":
                                $this->setAddress( "home", $value );
                                break;

                        case "address":
                        case "workaddress":
                                $this->setAddress( "work", $value );
                                break;

                        default:
                                $this->info[$property] = trim($value);
                                break;
                }
        }


        function getIndex( $owner, $indexKey )
        {
                $idx = array();

                if( $indexKey == 'letter' ) {
                        return Contact::getAlphabeticalIndex( $owner );
                }

                $cur = DB_select( "SELECT $indexKey, oid FROM contacts WHERE owner='$owner' ORDER BY $indexKey" );
                while( ($row = db_nextrow( $cur )) != NULL ) {
                        $key = strtolower($row[$indexKey]);
                        if( $key == '' )
                                $key = '_empty';
                        if( ! isset($idx[$key]) )
                                $idx[$key] = array();
                        $idx[$key][] = $row['oid'];
                }
                return $idx;
        }

        function getAlphabeticalIndex( $owner )
        {
                $cur = DB_select( "SELECT name, oid FROM contacts WHERE owner='$owner' ORDER BY name" );
                while( ($row = db_nextrow( $cur )) != NULL )
                {
                        if( $row['name'] == '' ) {
                                $key = '#';
                        } else {
                                $key = strtolower($row['name']{0});
                                $key = strtr( $key, '', 'aaaaeeeeiiiiooooyy' );
                                if( $key == ' '  )
                                        $key = '#';
                                if( ! strpos( "?abcdefghijklmnopqrstuvwxyz", $key ) )
                                        $key = '#';
                        }
                        $letter = strtoupper($key);
                        if( ! isset($idx[$letter]) )
                                $idx[$letter] = array();
                        $idx[$letter][] = $row['oid'];
                }
                return $idx;

        }

        function load( $oid )
        {
                empty($oid) && die( "missing oid in Contact::load" );
                $obj = new Contact();
                $obj->oid  = $oid;
                db_loadhash( "SELECT * FROM contacts WHERE oid=$oid", &$obj->info );
                // addresses are now loaded "on demand" for performance improves
                return $obj;
        }

        function initialize( $info )
        {
                $obj = new Contact();
                $obj->oid  = $info['oid'];
                $obj->info = $info;
                return $obj;
        }

        /*!
                Delete the contact with given oid and owner
                @return 1 if deletion went ok, 0 otherwise
                @static
        */
        function delete( $oid )
        {
            if( $oid ) {
               $eoid = db_escape( $oid );
               $cnt = db_query( "DELETE FROM contacts WHERE oid='$eoid'" );
               if( $cnt == 1 ) {
                  db_query( "DELETE FROM contact_address WHERE contact_oid=$eoid " );
                  return 1;
               }
               return 0;
            }
        }

        function store()
        {
            Webo::log( "Contact.store", LOG_DEBUG );
            if( @$this->oid ) {
               $this->info['modified'] = db_datetime(time());
               $this->makeInitials();
               db_updatehash( "contacts", $this->info, "oid" );
               db_exec( "DELETE FROM contact_address WHERE contact_oid=$this->oid" );
            }
            else {
               $this->info['created'] = db_datetime(time());
               $this->makeInitials();
               db_inserthash( "contacts", $this->info, "oid" );
               $this->oid = $this->info['oid'];
            }
            // insert postal addresses
            if( @is_array($this->addresses) ) {
               foreach( $this->addresses as $adrtype => $adr ) {
                     $adr['adrtype'] = $adrtype;
                     $adr['contact_oid'] = $this->oid;
                     db_inserthash( "contact_address", $adr );
               }
            }
        }

        /*!
                create the initials field from firstname and lastname fields.
                composed firstname are taken into account
                Ex: jean denis => JD, jean-claude denis => JCD
        */
        function makeInitials()
        {
                if( empty($this->info['firstname']) || empty($this->info['lastname']))
                        return;

                if( strpos($this->info['firstname'], "-" ) != NULL ) {
                        list($a,$b) = split( "-", $this->info['firstname'], 2 );
                        $ini = $a{0} . $b{0} . $this->info['lastname']{0};
                } else {
                        $ini = $this->info['firstname']{0} . $this->info['lastname']{0};
                }
                $this->info['initials'] = strtoupper($ini);
        }

        function setAddress( $adrtype, $adrHashorString )
        {
            Webo::log( "Contact::setAddress( $adrtype, $adrHashorString )", LOG_DEBUG );
            isset($this->addresses) or $this->addresses = array();
            if( empty($adrHashorString)) {
               $this->addresses[$adrtype] = NULL;
               return;
            }
            if( is_string($adrHashorString)) {
               $lines = split( "\r?\n", $adrHashorString );
               $adr['street'] = array_shift($lines);
               $else = array_shift($lines);
               if( $else ) {
                  @list( $cp, $loc, $country ) = split( " +", $else, 2 );
                  $adr['postalcode'] = $cp;
                  $adr['locality'] = $loc;
                  $adr['country'] = $country;
               }
            }
            else {
               $adr = $adrHashorString;
            }

            $this->addresses[$adrtype] = @array(
               'pobox' => $adr['pobox'],
               'locality' => $adr['locality'],
               'street' => $adr['street'],
               'extended' => $adr['extended'],
               'postalcode' => $adr['postalcode'],
               'region' => $adr['region'],
               'country' => $adr['country'],
            );
      }

      function getAddress( $adrtype )
      {
         if( empty($this->oid))
            return "";
          Webo::log( "Contact::getAddress( $adrtype )", LOG_DEBUG );
          db_loadhash( "SELECT * FROM contact_address WHERE contact_oid=$this->oid AND adrtype='$adrtype' ", $adrHash );
          return $adrHash;
        }
}

?>
