<?php
/*!
   Desktop provides utilities related to desktop module (home)

     $Id: Desktop.php,v 1.9 2003/05/14 09:06:39 lwest Exp $

*/

require_once("./lib/HTML/menu.php"); // for navbar

class Desktop
{
      /// switch to allow pagelets to be hidden using a DHTML recipee. may cause trouble on some navigators
   var $stackablePagelets = true;

   function Desktop()
   {
//      $this->owner = $user->userid;
   }

   function calendarPopup( $fieldName, $defaultTS=NULL )
   {
      ( $defaultTS == NULL ) && $defaultTS = time();
      return "<a href=\"#\" onClick=\"popCalendar('$fieldName' , $defaultTS)\">" . Icon( "obj/calendar") . "</a>";
   }

   function getNavbar()
   {
      $nav = new NavBar(); // in HTML/menu.php
      // go to Desktop
      $nav->addItem( new MenuItem( "?O=desktop", loc('Desktop'), "obj/desktop", "", "H" ));
      // go to Calendar
      $nav->addItem( new MenuItem( "?O=calendar", loc('Calendar'), "obj/calendar", "", "C" ));
      // go to Tasks
      $nav->addItem( new MenuItem( "?O=tasks", loc('Tasks'), "obj/tasks", "", "A" ));
      // go to Address book
      $nav->addItem( new MenuItem( "?O=abook", loc('Contacts'), "obj/contacts", "", "A" ));
      // go to Notes panel
      $nav->addItem( new MenuItem( "?O=note", loc('Notes'), "obj/notes" ));
      // TODO : these items are module dependants
      $nav->addItem( new MenuItem( "javascript:PagePrint();return false;", loc('Print'), "task/print", "Print page", "P" ));
      $nav->addItem( new MenuItem( "?O=config&M=calendar/config", loc('Config'), "task/configure", "", "Configure calendar"));
      $nav->addItem( new MenuItem( "javascript:Help('calendar');return false;", loc('Help'), "task/help", "Getting help", "F1" ));
      $nav->addItem( new MenuItem( "javascript:Logout();return false;", loc('Logout'), "task/logout", "Log out", "" ));
      return $nav;
   }

   /*!
      Display an clickable icon - for now only used on the desktop page
      @param jsCode javascript code when icon is clicked
      @param iconID icon identifier eg. "task/logout"
      @param label the text under icon
      @param tiptext text displayed when mouse gets over the icon
   */
   function printShortcut( $jsCode, $iconID, $label, $tiptext )
   {
   ?>
         <table class="hoverBtn" height="44" width="52" onclick="<?php echo $jsCode; ?>" >
                  <tr><td align="center" title="<?php echo loc($tiptext) ?>" valign="middle" style="overflow:hidden;">
   <?php
         echo Icon( $iconID, NULL );
         ?></td></tr><tr><td align="center" style="color:white;font-weight:bold"><?php echo loc($label) ?></td></tr></table>
   <?php

   }
   
   
   /*!
      list the configuration plugins.
      each plugin is represented by an array( "page", "reserved", "configuration page title" )
      where page is : modules/[modulename/page].php
      used in config/index.php
   */
   function listConfigurationPlugins()
   {
      return array(
         array( 'base/config-language' , "",  "General : Language & Localization" ),
         array( 'desktop/config-pagelets' , "",  "Desktop : Pagelets" ),
         array( 'desktop/config-shortcuts' , "",   "Desktop : Shortcuts" ),
         array( 'themes/config' , "",   "Colors & Global Look" ),
         array( 'calendar/config' , "",   "Calendar" ),
         array( 'abook/config' , "",   "Address Book" ),
      );
   }

   /*!
      list of all possible active icons
      displayed on Desktop left-side
      each item is composed of a location, an iconID, a label and a description (displayed as tooltip )
   */
   function listShortcuts()
   {
      global $user;
      $userRoles = $user->listRoles();
      $scs =array (
         array( "window.location='?O=desktop&A=about'", "task/about", "About...", "More informations about WebO", 'webo-user' ),
         array( "window.location='?O=abook'", "obj/contacts", "Contacts", "AddressBook", 'webo-user' ),
         array( "window.location='?O=tasks'", "obj/tasks", "Todos", "Open The Todo List", 'webo-user' ),
         array( "window.location='?O=event&A=add'", "task/newevent", "Event", "Plan a meeting or an event", 'webo-user' ),
         array( "window.location='?O=todo&A=add'", "task/newtodo", "Todo", "Add an item in your todo list", 'webo-user' ),
         array( "window.location='?O=contact&A=add'", "task/newcontact", "Contact", "Add a contact to your addressbook", 'webo-user' ),
         array( "window.location='?O=note&A=add'", "task/newnote", "Note", "Add a  note", 'webo-user' ),
         array( "window.location='?O=config&M=desktop/config-pagelets'", "task/configure", "Config", "Configure Desktop", 'webo-config' ),
         array( "window.location='?O=admin'", "obj/admin", "Admin", "WEBO Administration Module", 'webo-admin' ),
         array( "window.location='?O=dump'", "obj/bug", "Debug", "Debug informations for development purpose", 'webo-developer' ),
         array( "PagePrint()", "task/print", "Print", "Print this page", 'webo-user' ),
         array( "Help('desktop')", "task/help", "Help", "Getting help about the Desktop page", 'webo-user' ),
         array( "Logout()", "task/logout", "Logout", "End Your Session", 'webo-user' ),
       );
      $out = array();
      foreach( $scs as $sc ) {
         if( in_array( $sc[4], $userRoles))
            $out[] = $sc;
       }
       return $out;
   }


   function ErrorPage( $title, $msg )
   {
      PageHead();
      echo '<div align="center"><p>';
      $desk = new Desktop();
      $desk->stackablePagelets = false;
      $desk->PageletHead( @$title, Icon('flags/error'), "", 400 );
      RowDef("style='padding: 16px'" );
      RowN("<br><p>". nl2br( $msg) . "</p><br>" );
      $desk->PageletEnd();
      PageEnd();
      exit;
   }

   /*!
      start a Pagelet (small inner-page content)
         parameters:
         @title: title show in titlebar of pagelet
         @leftCell : HTML content to display on the left-end of the titlebar, usually buttons
         @rightCell : HTML content to display on the right-end of the titlebar, usually buttons
         @width: module width in pixel
         @url: link on the title
   */

   function pageletHead( $title, $leftCell="&nbsp;", $rightCell="&nbsp;", $width=200, $url="", $enableStack=true )
   {
      global $HTTP_COOKIE_VARS;
      if( $url != "" )
         $title = TextLink( $url, $title, 'class="menu" style="font-weight:bold;"' );
      // dynamic stacking code
      if( isset($this->pglID) )
         $this->pglID++;
      else
         $this->pglID  =  "pgl01";
      if( $this->stackablePagelets && $enableStack ) {
         $stackableCode = "id=\"$this->pglID\" ";
         $onclick = "minimizePagelet('$this->pglID')";
         $rightCell .= IconLink( "javascript:$onclick", "task/maximize" );
         if( @$HTTP_COOKIE_VARS["webo_desktop_$this->pglID"] )
            $stackableCode .= ' style="display:none" '; // this pagelet was stacked-up by user
      } else {
         $stackableCode = "";
      }
   ?>
   <!-- PageletHead -->
   <table class="module" width="<?php echo $width ?>" cellspacing="0" border="0">
   <tr>
         <td class="winTitle" >
         <table class="winTitle" width="<?php echo $width ?>" cellspacing="0" cellpadding="0">
                  <tr>
                  <td align="left" nowrap><?php echo $leftCell ?></td>
                  <th class="winTitle" width="94%" style="letter-spacing: 1px"><?php echo $title ?></th>
                  <td align="right" nowrap><?php echo $rightCell ?></td>
                  </tr>
         </table>
         </td>
   </tr>
   <tr <?php echo $stackableCode ?> ><td>
   <!-- endPageletHead -->
   <?php

   }

   /*

         TODO : integrate statusBar
   */
   function PageletEnd( $statusBar = "", $statusFlag=NULL )
   {
      if( $statusBar ) {
   ?>
   <tr>
         <td class="winTitle" width="100%">
      <?php
         if( in_array( $statusFlag, array('tip','info','error','warning','notice') ) )
                  echo Icon( "flags/$statusFlag", 'valign="bottom" ' );
         echo "&nbsp;$statusBar";
   ?>
   </td>
   </tr>
   <?php } ?>
   </td></tr>
   </table>
   <!-- PageletEnd -->
      <?php

   }



} // end class Desktop


?>
