<?php

/***
   minimal users group implementation

*/

class Group
{
   var $oid = NULL;
   var $name = NULL;
   var $manager_oid = NULL;
   var $description = NULL;
   var $email = NULL;

function Group()
{

}

function load( $oid )
{
   $grp = new Group();
   $grp->oid = $oid;
   $info = array();
   db_loadhash( "SELECT * FROM groups WHERE oid=$oid", &$info );
   $grp->name = $info['name'];
   $grp->description = $info['description'];
   $grp->email = $info['email'];
   $grp->created = $info['created'];
   $grp->modified = $info['modified'];
   return $grp;
}

function store( $oid )
{
   if( $this->oid ) {
      db_updateobject( "groups", $this, "oid" );
   } else {
      db_insertobject( "groups", $this, "oid" );
   }
}

/*
   return an array of groups (returned as hash)
   @static
*/
function listGroups()
{
   return db_arraylist("SELECT * FROM groups ORDER BY name" );
}

/*
   return true if given user is a member of the given group oid
   static version
   @static
*/
function isMember( $group_oid, $user )
{
   // lazy
   return in_array( $user->getGroups(), $group_oid);
}

/*!
   @return array members of this Group
*/
function listMembers()
{
   $members = db_arraylist( "SELECT users.* FROM users, groupmembers mb
      WHERE gu.group_oid=$this->oid AND mb.userid=users.userid" );
   return $members;
}


/*!
   @return array members of this Group
*/
function listMemberUserids()
{
   $members = db_loadarray( "SELECT contact_oid FROM groupmembers mb WHERE group_oid=$this->oid" );
   return $members;
}


function addMember( $userid, $role='member' )
{
   $uid = db_escape($userid);
   $rol = db_escape($role);
   db_exec( "DELETE FROM groupmembers WHERE group_oid=$this->oid AND userid='$uid'" );
   db_exec( "INSERT INTO groupmembers(group_oid,userid,role) VALUES($this->oid,'$uid','$rol' )" );
}

/*
  update all group members at once
  @param $userhash : a hash of the form <userid> => <role in group>
  @return 1 if ok, 0 otherwise
*/
function setMembers( $userids )
{
   $ret = db_exec( "DELETE FROM groupmembers WHERE group_oid=$this->oid" );
   $sth = db_prepare( "INSERT INTO groupmembers(group_oid,userid,role) VALUES($this->oid,?,? )" );
   foreach( $userhash as $userid => $role ) {
      $ret &= $sth->execute($userid,$role);
   }
   return $ret;
}

function removeMember( $userid )
{
   $uid = db_escape($userid);
   db_exec( "DELETE FROM groupmembers WHERE group_oid=$this->oid AND userid='$uid'" );
}

function listGroupsAsHash()
{
   return db_loadhashList("SELECT oid,name FROM groups ORDER BY name" );
}

function listGroupsForUser( $userid )
{
   $uid = db_escape($userid);
   return db_loadhashList("SELECT g.oid, g.name FROM groups g,groupmembers m
      WHERE g.oid=m.group_oid AND m.userid='$uid' ORDER BY g.name" );
}

}

?>
