<?php
/*
A Note object

History
        $Log: Note.php,v $
        Revision 1.4  2003/04/23 00:13:38  lwest
        removed debug() calls

        Revision 1.3  2003/03/19 02:00:21  lwest
        tab stuff

*/

class Note
{

        /* properties :
                $oid,
                $owner,
                $summary autocalculated from description
                $description
        */

        function Note()
        {
                $this->info = array();
        }

        function check()
        {
                if( $this->info['description']  == "" )
                        return "content is required";
                return "OK";
        }

        // get a property
        function get( $property )
        {
                $property = strtolower( $property);
                if( empty($this->info[$property]))
                        return NULL;
                else
                        return $this->info[$property];
        }


        // set a property to the value
        function set( $property, $value )
        {
                $property = strtolower( $property);
                $value = trim( $value);
                if( $value == "" )
                        $value = NULL;

                switch( $property ) 
                {
                case 'description':
                        $this->info[$property] = $value;
                        if( ($pos= strpos( $value,"\r")) != -1 )
                                $summary = substr( $value, 0, $pos -1 );
                        elseif( ($pos= strpos( $value,"." )) != -1 )
                                $summary = substr( $value, 0, $pos -1 );
                        else
                                $summary = substr( $value, 0, 59 );				
                        $this->info['summary'] = $summary;
                        break;

                default:
                        $this->info[$property] = $value;
                }
        }

        function initialize( $info )
        {
                $obj = new Note();
                $obj->oid  = $info['oid'];
                $obj->info = $info;
                return $obj;
        }

        /*!
                Delete the note with given oid and owner
                @return 1 if deletion went ok, 0 otherwise
                @static
        */
        function delete( $owner, $oid )
        {
                if( $oid && $owner )
                {
                        $eoid = db_escape( $oid );
                        $eowner = db_escape( $owner );
                        $cnt = db_query( "DELETE FROM notes WHERE oid='$eoid' AND owner='$eowner'" );
                        return $cnt;
                }
        }


        function load( $owner, $oid )
        {
                empty($oid) && die( "missing oid in Note.load" );
                $eowner = db_escape($owner);
                $eoid = db_escape($oid);
                $obj = new Note();
                $obj->oid  = $oid;
                db_loadhash( "SELECT * FROM notes WHERE oid=$eoid AND owner='$eowner'", &$obj->info );
                return $obj;
        }

        function store()
        {
                if( @$this->oid ) {
                        $this->info['modified'] = db_datetime(time());
                        db_updatehash( "notes", $this->info, "oid" );

                } else {
                        $this->info['created'] = db_datetime(time());
                        db_inserthash( "notes", $this->info, "oid" );
                        $this->oid = $this->info['oid'];
                }
        }

}

?>
