<?php
/*

Webo class

DESCRIPTION

a global class that handle tasks related to webo session, authentication , etc.

VERSION
        $Id: Webo.php,v 1.23 2003/05/20 18:43:30 lwest Exp $

INFORMATIONS
        author : Leo West <west_leo@removeme.yahoo.com>

$Id: Webo.php,v 1.23 2003/05/20 18:43:30 lwest Exp $

*/

class Webo
{
        var $sessionKey = NULL;
        var $dtStart = NULL;
        var $recents = array();

function Webo()
{
   $this->WEBO_URL = $GLOBALS['WEBO_URL'];
}


function addRecent( $obj )
{
   if( ! is_object($obj))
      return false;
   if( count($this->recents) == 20 )
      array_shift($this->recents);

   $recent = array(
      'oid' => $obj->oid,
      'class' => get_class($obj),
      'lastmod' => time()
   );
   array_push( $this->recents[], $recent );
}

function listRecents( $filterClass, $count = 15 )
{
   $a = array();
   $cnt = 0;
   foreach( $this->recents as $recent )
   {
      if( $filterClass != NULL && $recent['class'] == $filterClass )
         $a[] = $recent['oid'];
      if( $cnt ++ > $maxcount )
         break;
   }
   return $a;
}

/**************
        authentication methods
*/

/**
        is current visitor authenticated ?
*/
function checkAuthent()
{
   return( session_is_registered('user') );
}


function anonymousAccess()
{
   global $profile, $user;
   $profile = Webo::defaultProfile();
   $user = new stdClass();
}

function checkAccess( $sAllowedRole )
{
   global $user, $WEBO_URL;
   
   // anonymous acces requires a very special treatment
   if( $sAllowedRole == 'anonymous' ) {
      if( ! is_object( $user )) {
         Webo::anonymousAccess();
       }
       return true;
   }
   
   // is user authenticated  ? not => go to login form
   if( ! @is_object($user)) {
      // redirect to login form and exit
      Webo::log( "Webo::checkAuthent : false", LOG_NOTICE );
      header( "Location: $WEBO_URL/signin.php" );
      exit();      
   }
   
   $userRoles = $user->listRoles();
   if( @in_array($sAllowedRole,$userRoles)) {
      return true;
   } else {
      require_once( "./lib/HTML/form/button.php" );
      $btnBack = new Button( '&lt; Back', 'history.go(-1)', 'class="btnM"' );
      $sBtn = $btnBack->toString();
      Desktop::ErrorPage(
         'Error detected : ' . loc('Access denied') ,
         "Your user profile doesnt allow you to access this module or page.
         Contact Your Webo administrator for more informations.
         [granted role is $sAllowedRole]
         <center>$sBtn</center>
         " );
   }
}

function createSessionKey()
{
        extract( $GLOBALS['HTTP_SERVER_VARS'] );

        $id = "XXXX";
        $str = "";

        if( isset($HTTP_USER_AGENT)) {
                $id{0} = 'U';
                $str .= $HTTP_USER_AGENT;
        }
        if( isset($REMOTE_ADDR)) {
                $id{1} = 'R';
                $str .= $REMOTE_ADDR;
        }
        if( isset($HTTP_ACCEPT_LANGUAGE)) {
                $id{2} = 'L';
                $str .= $HTTP_ACCEPT_LANGUAGE;
        }
        if( isset($HTTP_ACCEPT_ENCODING)) {
                $id{3} = 'E';
                $str .= $HTTP_ACCEPT_ENCODING;
        }
        $key = $id . '.' . md5($str);
        return $key;
}

function verifySessionKey()
{
   global $HTTP_SERVER_VARS;
   if( $this->sessionKey == NULL ) {
      $this->log( "sessionKey is null", LOG_WARNING );
   }
   else if( strlen($this->sessionKey) < 4 ) {
      $this->log( "sessionKey too short", LOG_WARNING );
   }
   else {
      $id = substr($this->sessionKey, 0, 4 );
      $str = "";
      if( $id{0} == 'U' && isset($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
               $str .= $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
      }
      if( $id{1} == 'R' && isset($HTTP_SERVER_VARS['REMOTE_ADDR'])) {
               $str .= $HTTP_SERVER_VARS['REMOTE_ADDR'];
      }
      if( $id{2} == 'L' && isset($HTTP_SERVER_VARS['HTTP_ACCEPT_LANGUAGE'])) {
               $str .= $HTTP_SERVER_VARS['HTTP_ACCEPT_LANGUAGE'];
      }
      if( $id{3} == 'E' && isset($HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING'])) {
               $str .= $HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING'];
      }

      $genkey = $id . '.' . md5($str);

      if( $genkey == $this->sessionKey ) {
               return true;
      } else {
               $this->log( "bad sessionKey:$genkey", LOG_WARNING );
               return false;
      }
   }
}


function endSession()
{
        global $user, $context, $profile;

        // TODO : user stat updates

        // save profile changes
        $this->storeProfile($profile);

        include_once( "./modules/desktop/handlers.php" );
        desktop_session_end();

        include_once( "./modules/calendar/handlers.php" );
        calendar_session_end();

        include_once( "./modules/abook/handlers.php" );
        abook_session_end();

        session_unregister("user");
}


function startSession()
{
   global $user, $profile;
   $this->createSessionKey();
   $profile = $this->loadProfile( $user->userid );
   session_register( "profile" );

   $this->dtStart = Date::format("%H:%M:%S", time() );

   // each module does its own initializations in <modulename_session_start()>
   include_once( "./modules/desktop/handlers.php" );
   desktop_session_start();

   include_once( "./modules/calendar/handlers.php" );
   calendar_session_start();

   include_once( "./modules/abook/handlers.php" );
   abook_session_start();

   // update user's last access time
   $euid = db_escape($user->userid);
   $ts = db_datetime(time());
   db_exec( "UPDATE users SET lastaccess='$ts' WHERE userid='$euid'" );

   $this->log( "webo session started", LOG_INFO, 'session.start' );

}

/*!
        load the user profile informations into an hash array
        @table useprofile
        @return array profile infos
*/
function loadProfile( $userid )
{
   $profile = $this->defaultProfile();
   // then fetch user profile
   if( $userid != NULL ) {
      $uid = db_escape($userid);
      $userprofile = db_loadhashList( "SELECT name,value FROM userprofile WHERE userid='$uid' " );
      $profile = array_merge( $profile, $userprofile );
   }

   // multivalued profile keys
   foreach( $profile as $k => $v )
   {
      // process a multiple values entry, aka pagelets[]
      if( preg_match( '/^(.*)\[(.+)\]$/', $k, $parts ) )
      {
         if( ! @is_array($profile[$parts[1]]) )
               $profile[$parts[1]] = array();
         $profile[$parts[1]][$parts[2]] = $v;
         unset( $profile[$k] );
      } else {
         $profile[$k] = $v;
      }
   }
   return $profile;
}

/*!
 return a default profile 
 usefull when a user connects for the first time, and has no profile
 called whenever a session starts to add any new profile keys created by an upgrade or manually added by an admin
*/
function defaultProfile()
{
   // set global configuration first
   /*
   $profile = array(
      'defaultSharing' => 0,
      'defaultSharingGroup' => NULL,
      'defaultSharingAccess' => 'RW',
      'locale' => 'en',
      'lang' => 'uk',
   );*/
   $profile = db_loadhashList( "SELECT name,value FROM userprofile WHERE userid='(default)'" );
   return $profile;
}


/*!
        store a couple (key,value) in current user profile
        @param string the profile key, such as calendar_starttime
        @param string or array the value to store
*/
function setPref( $profilekey, $value )
{
   global $profile; // TODO : encapsulated in Webo
   if( ! isset($profile) || ! is_array($profile)) {
      return false;
   }
   $profile[$profilekey] = $value;
   return true;
}


/*
      set group sharing on an object $obj
      @param object a webo-compliant object
      @param int 1 to share, 0 to unshare the object
      @param string group oid to share this object with or NULL
      @param string access ACL : [ R, RW, RWD]
*/
function setACI( $target, $doshare, $share_group, $share_access='R'  )
{
   if( is_object($target) && method_exists($target,"set" ) )
   {
      if( $doshare == 1 && isset($share_group) ) {
         if( $share_access != 'R' &&  $share_access != 'RW' &&  $share_access != 'RWD' ) {
            Webo::log( "Webo::setACI : bad permissions : $share_access ", LOG_WARNING );
            return false;
         }
         $target->set( "group_oid", $share_group);
         $target->set("group_access", $share_access );
      }
      // do not share
      else {
         $target->set( "group_oid",NULL);
         $target->set("group_access", NULL );
      }
      // store sharing parameters in the context for user convenience
      $this->setPref( 'defaultSharing', $doshare );
      $this->setPref( 'defaultSharingGroup', $share_group );
      $this->setPref( 'defaultSharingAccess', $share_access );
   } else {
      Webo::log( "null target or no setter on $target in Webo::setACI", LOG_WARNING );
   }
}

/*!
        store profile into the datastore
        @param array the profile infos to store
*/
function storeProfile( $profile )
{
        global $user;
        if( ! is_array($profile) )
                return;
        $this->log( "Webo.storeProfile", LOG_INFO );
        $sth = db_prepare( "DELETE FROM userprofile WHERE userid=?" );
        db_execute( $sth, $user->userid );

        $item = array( 'userid' => $user->userid );
        foreach( $profile as $k => $v )
        {
                $item['name'] = $k;
                if( is_array($v)) {
                        foreach( $v as $k2 => $v2 )
                        {
                                $item['name'] = $k . '['. $k2 . ']';
                                $item['value'] = $v2;
                                db_inserthash( "userprofile", $item ) or die( "profile_store($k) failed");
                        }
                }
                else {
                        $item['value'] = $v;
                        db_inserthash( "userprofile", $item ) or die( "profile_store($k) failed");
                }
        }
}

/*!
        insert a log into the application log system
        log can be used for critical errors (level=crit), application errors (error)
        warnings (level=warn), normal actions (notice) or statistics purpose (stat)
        @param msg the log message, should not exceed 255 car.
        @param level the log level - default to LOG_NOTICE - other levels : LOG_INFO, LOG_ERR, LOG_DEBUG, LOG_WARNING
        @param extra info (<40 cars) can contain any string for sort/filter purpose : module name, php page for instance.
        @static both static and instance calls are possible
*/
function log( $msg, $level=LOG_NOTICE, $appcode=NULL )
{
   global $LOG_METHOD, $LOG_LEVEL;
   // only log important events
   if( $level > $LOG_LEVEL )
      return;
   if( @is_object($GLOBALS['user']) )
      $userid = $GLOBALS['user']->userid;
   else
      $userid = NULL;
   if( $LOG_METHOD == 'db' ) {
      $sth = db_prepare( "INSERT INTO webolog( msg, level, userid, appcode, ts ) VALUES( ?,?,?,?,NOW() )" );
      db_execute( $sth,$msg, $level, $userid, $appcode );
   } else {
      syslog(  LOG_USER + $level, "[webo] $msg user=$userid appcode=$appcode" );
   }
}


/*!
   new stuff in beta to automatize the process "got an error in data processing, go back to edition form page
   with an error message

*/
function setFormUrl( $url )
{
   $this->formUrl = $url;
   $this->formErrorMsg = ""; // reset this
}

function formError( $message, $widgetName=NULL )
{
   $this->formErrorMsg = $message;
   $this->formWidgetName = $widgetName;
   return false;
}

// access level permission for sharing objects among groups
function listSharingLevels()
{
        return array(
                'R' => 'read only',
                'RW' => 'read,edit',
                'RWD' => 'read,edit,delete',
        );

}

function timer( $name_or_timerid, $logresult=false )
{
   list( $ms, $ts ) = explode( " ", microtime());
   if( is_array($name_or_timerid)) {
      $delta = sprintf( "%0.3f", $ms+$ts - $name_or_timerid['ts'] );
      // we automatically log this timer result via webo common logger, at LOG_INFO level
      if( $logresult ) {
         Webo::log( "timer $name_or_timerid[name] : $delta secs", LOG_INFO );
      }
      return $delta;
   }else{
      $timer = array( 'ts' => $ms + $ts, 'name'=>$name_or_timerid );
      return $timer;
   }
}

}
// end class Webo


?>
