<?php

class Admin
{

   function generatePassword( $len = 8 )
   {
      $cons = array( "a", "e", "i", "o", "u", "y" );
      $numcons = count($cons);
      $pwd= "";
      mt_srand ((double) microtime() * 1000000);
      for($i=0; $i<$len; $i++ )
         if( $i %2 )
            $pwd .= $cons[mt_rand(0,$numcons-1)];
         else
            $pwd .= chr(mt_rand( 97,122 ));
      return $pwd;
   }

   function changePassword( $user, $oldpwd, $newpwd, $newpwdconfirm )
   {
      $oldpwd = $user->userpassword;

      if( md5($oldpwd) != $user->userpassword ) return "Bad password";
      if( $newpwd != $newpwdconfirm ) return "password mismatch";
      if( strlen( $newpwd ) < 3 ) return "New password too short, 3 car. minimum";
      if( $newpwd == $user->userid ) return "New password too weak";
      $user->userpassword = md5($newpwd);
      $user->Store();
      return NULL;
   }

   function userTemplate()
   {
      $user = new User();
      $user->roles = array( 'webo-user', 'webo-config' );
      $user->userpassword = Admin::generatePassword(6); // len = 6
      $contact = new Contact();
      $contact->set( 'class','user');
      $contact->set( 'owner','webo-adm' );
      $user->contact = $contact;
      return $user;
   }

   function userExists( $userid )
   {
      $euid = db_escape($userid);
      $cnt = db_query("SELECT * FROM users WHERE userid='$euid' " );
      return $cnt;
   }

      /*!
   List ALL roles
   return an array
   @return array list of Webo roles
   */
   function listRoles()
   {
      $roles = db_loadhashlist("SELECT role,concat( role ,' : ',description) FROM autrole WHERE status=0 ORDER BY role DESC" );
      return $roles;
   }

   function listUserStatus()
   {
      return array(
         'enabled',
         'disabled',
         'locked',
         'deleted',
      );
   }

   function userInsert( $infos )
   {
      $msg = Admin::userCheck( $infos );
      if( $msg )
         return $msg;
      extract( $infos );
      $user = new User();
      $user->userid = $userid;
      $user->userpassword = md5($userpassword);
      $user->status = $status;
      $ret = db_insertObject( "users", $user );
      if( $ret ) {
         $user->setRoles( $roles);
         // create associated contact object and insert it
         extract( $infos );
         $ctc = new Contact();
         $ctc->set( "class", 'user' );
         $ctc->set( "owner", 'webo-adm' );
         $ctc->set( "firstname", $firstname );
         $ctc->set( "lastname", $lastname );
         $ctc->set( "userid", $userid );
         $ctc->set( "email1", $email1 );
         $ret = $ctc->store();
      }
      return $ret;
   }

   /*
      verify user informations - to be used before an insert or update
   */
   function userCheck( &$infos )
   {
      extract( $infos );
      $msg = "";
      if( empty($userid) )
         $msg = "User identifier is required";
      if( ! preg_match( "/^[\w\d\.-_]+$/", $userid) )
         $msg = "User identifier is invalid";
      if( empty($userpassword) )
         $msg = "User password is required";
      if( isset($userpassword2) && $userpassword != $userpassword2 )
         $msg = "Passwords mismatch";
      if( count($roles) == 0 )
         $msg = "Select at least one role for user";
      if( empty($email1) )
         $msg = "Email is required";
      if( ! preg_match( "/^[\w\.-_]+@\w+(\.\w+)*$/", $email1) )
         $msg = "Email invalid";
      if( ! in_array($status, Admin::listUserStatus() ) )
         $msg = "Unknown user status";
      if( empty($lastname) )
         $msg = "Last name required";
      return $msg;
   }

}

?>
