<?php

$where = NULL;

// todo other filters
if( isset($filter) ) {
   if( $filter == 'active' )
      $where = "status <> 'CANCELLED' AND status <> 'COMPLETED'";
   elseif( $filter == 'completed' )
      $where = "status = 'COMPLETED' ";
   elseif( $filter == 'closed' )
      $where = "status IN ( 'COMPLETED', 'CANCELLED') ";
}

$tsmin = @strtotime($dmin);
$tsmax = @strtotime($dmax);

if( empty($dmin) or empty($dmax ))
{
   if( ! $where )
      db_loadhash( "SELECT MIN(tscreated) as tsmin, MAX(tsmodified) as tsmax FROM todos WHERE $tasklist->ACIsql",  $a );
   else
      db_loadhash( "SELECT MIN(tscreated) as tsmin, MAX(tsmodified) as tsmax FROM todos WHERE $where AND $tasklist->ACIsql",  $a );
   if( empty($dmin))
      $tsmin = $a['tsmin'];
   if( empty($dmax))
      $tsmax = $a['tsmax'] + 86400 * 3;
}


$dmin = new Date($tsmin);
$dmax = new Date($tsmax);

$days = $dmin->daysTo( $dmax );
$weeks = round($days / 7 );
$tdwidth = round( 800 / $weeks );
$dscale = $dmin;



$oids = $tasklist->listOids( $where );

$vp= new ViewPort( $tsmin, $tsmax, 800 );

?>
<style type="text/css">
.itvTodo { border:1px solid gray; }
</style>
<form name="frmList">
<input type="hidden" name="O" value="<?php echo $O; ?>">
<input type="hidden" name="A" value="">

<table class="grid" align="center" width="800" cellspacing="0" style="border:1px">
<tr >
<?php
   $gridrow = "";
   for($i=0; $i< $weeks; $i++ ) {
 ?>
   <td class="listTitle" width="<?=$tdwidth ?>"><?= $dscale->toString('%d/%m') ?></td>
<?php
      $dscale->addDays(7);
      $gridrow .= '<td style="width:2px;border-right:1px solid blue;" align="left"></td>' . "\n";
   }
?>
</tr>
<tr><td colspan="8">
<?php

foreach( $oids as $oid )
{
   $style ="";
   $iconA = NULL;
   $iconB = NULL;
   $todo = $tasklist->get($oid);
   $tmin = $todo->get('tscreated');
   switch( $todo->get('status')) {
   case "IN-PROCESS":
      $tmax = time();
      $iconA = icon("flags/in-process.png");
      $style = "border-right: 0px;";
      break;
   case "NEEDS-ACTION":
      //$iconA = icon("flags/stopped.png");
      $tmax = time();
      $style = "border:none;border-bottom-style: dashed;";
      break;
   case "CANCELLED":
      $iconB = icon("flags/cancelled.png");
      $tmax = $todo->get('tsclosed');
      $style = "border:none;border-left: 1px solid;border-bottom-style: dashed;";
      break;
   case "COMPLETED":
      $iconA = icon("flags/in-process.png");
      $iconB = icon("flags/completed.png");
      $tmax = $todo->get('tsclosed');
      break;

   }
   list( $x1, $x2 ) = $vp->positionInterval( $tmin, $tmax );
   // we skip tasks out of our range (allready finished)
   if( $x2 < 0 )
      continue;
   $y = $vp->y;
   placeInterval($x1,$x2,$todo, $style,$iconA, $iconB );
   $vp->nextRow();
}


function placeInterval( $a, $b, $todo, $cssStyle, $rightIcon, $leftIcon )
{
   global $gridrow,$weeks;

   $width = ($b -$a );
   $summary = Textlink( "?O=todo&A=edit&oid=" . $todo->get('oid'), $todo->get('summary') );
   $dopen = $todo->get('created');
   $dclosed = $todo->get('closeddate');

   $allinfo = $todo->get('summary') . "\ncreated:$dopen \ncompleted:$dclosed \nstatus:" . $todo->get('status');
   $positionning = ";position:relative;height:18px;overflow:hidden;width:". $width ."px; left:" . $a . "px";


?>
<tr><?= $gridrow ?></tr>
<tr>
<td colspan="<?=$weeks ?>">
<span class="itvTodo" style="<?= $cssStyle ?>;<?=$positionning?>" title="<?= $allinfo ?>">
   <table spacing="0" padding="0" width="100%" ><tr valign="top" >
      <td align="left" width="10"><?= $rightIcon ?></td>
      <td><?= $summary ?></td>
      <td align="right" width="10"><?= $leftIcon ?></td>
   </tr></table>
</span>
</td>
</tr>
<?php
}

?>

</td></tr>
</table>
<br clear="all" />

<?php


class ViewPort
{

   function viewPort( $pmin, $pmax, $width )
   {
      $this->width = $width;
      $this->pmin = $pmin;
      $this->pmax = $pmax;
      $this->coef = $this->width / ( $this->pmax - $this->pmin );
      $this->y = 0;
   }


   function positionInterval( $p1, $p2 )
   {
      if( $p1 < $this->pmin )
         $x1 = -1;
      else
         $x1 = (int) (($p1 - $this->pmin ) * $this->coef);
      $x2 = (int) ( ($p2 - $this->pmin) * $this->coef);
      return array( $x1, $x2 );
   }

   function nextRow()
   {
//      $this->y += $this->rowheight;
   }

}


?>
