<?php

// update cache every 8 minutes
$CACHE_UPDATE_INTERVAL = 60 * 8;

// user agent
include_once( "./lib/net/HTTP/client.php" );
include_once( "./lib/webo/Webo.php" );

$timer = Webo::timer("webspider");

$http = new Net_HTTP_Client();

$sql = "SELECT * FROM webcache
            WHERE ( wbc_nextupdate < ? OR wbc_lastupdated IS NULL )
            AND wbc_status <> 'DISABLED' AND wbc_status <> 'DELETED' ";

$sth = db_prepare( $sql );

$ts1 = time(); // should be scheduled every 10 minutes
// $ts2 = time() + 10*60; // should be scheduled every 10 minutes
$cur = db_execute( $sth, $ts1 );
$numok=$numerrors=0;
echo "<pre>";
while( ($itm = db_nextrow($cur)) )
{
   print_r($itm);
   if( $itm['wbc_url'] == "" )
      continue;

   $ret = $http->get($itm['wbc_url']);
   if( $ret != 200 ) {
      echo "ret=$ret\n";
      db_prepare( "UPDATE webcache SET wbc_status='GET-ERROR' WHERE wbc_id=$itm[wbc_id]" );
      // TODO : howto handle eventual cached data : destroy, mark as "notfresh" ?
   // web fetch went fine, we store fetched data in cache
      $numerrors ++;
   } else {
      // TODO : use content-type, content-length ?
      $data = $http->getBody();
      $cachefile = Webo::addCacheFile( $itm['wbc_url'], $data, 'encodename' );
      $tsnow = time();
      $tsnext = $tsnow + $CACHE_UPDATE_INTERVAL;
      $sth2 = db_prepare( "UPDATE webcache SET wbc_cachefile=?,wbc_lastupdated=?,wbc_nextupdate=?,wbc_status=? WHERE wbc_id=? " );
      db_execute( $sth2, $cachefile, $tsnow, $tsnext, 'IN-CACHE', $itm['wbc_id'] );
      $numok ++;
   }
   // print_r($http);
}

echo "</pre>";

// re-enable items taht where unreachable last fetch time
$sqlreactivate = "UPDATE webcache SET status='ACTIVE' WHERE status='DISABLED' ";
db_exec( $sqlreactivate);

// re-enable items taht where unreachable last fetch time
$sqlreactivate = "UPDATE webcache SET status='ACTIVE' WHERE status='DISABLED' ";
db_exec( $sqlreactivate);

$http->disconnect();

$sec = Webo::timer($timer);

Webo::log( "[webspider task] :updated $numok webcaches, got $numerrors errors in $sec seconds", LOG_NOTICE );

?>
