#! /usr/local/bin/php
<?php

chdir("..");

include_once( "./webo.conf.php" );
include_once( "./lib/webo/cache.php" );
include_once( "./lib/db/db.mysql.php" );
include_once( "./lib/file/cache.php" );
include_once( "./lib/net/HTTP/client.php" );

// open a connection to the database
db_connect($DB_URL);



$webocache = new webo_cache();

$scriptname = array_shift( $argv );
$action = @array_shift( $argv );

switch( $action )
{

case 'add':
	@list( $url, $name, $owner ) = $argv;
	if( $url == "" ) 
		usage( "url required" );
	$webocache->insertUrl( $url, $owner, $name );
	break;
	
case 'del':
	@list( $url ) = $argv;
	if( $url == "" ) 
		usage( "url required" );
	$webocache->removeUrl( $url );
	break;
	

case 'update':
	@list( $force ) = $argv;
	$webocache->updateCache( $force, 'verbose' );
	exit();
	
default:
	usage();
	break;

}


function usage( $msg = NULL )
{
	global $scriptname;
	$msg && print "error : $msg \n";
	echo "Usage: $scriptname [add|update]	<optional parameters>
   - update                                    : update all items in the cache
   - add <url> [description] [owner userid]    : add given url in the cache. description is a short overview of this url
   - del <url>                                 : remove an url from cache
";
	die();
}


?>
